<?php

namespace Coming_Soon_Widgets;

class Plugin
{

  private static $_instance = null;

  public static function instance()
  {
    if (is_null(self::$_instance)) {
      self::$_instance = new self();
    }
    return self::$_instance;
  }

  public function widget_scripts()
  {
    wp_register_script('coming_soon_widgets_script', plugins_url('/assets/js/coming-soon-widgets-script.js', __FILE__), ['jquery'], false, true);
  }

  public function widget_styles()
  {
    wp_register_style('font-awesome', ELEMENTOR_ASSETS_URL . 'lib/font-awesome/css/font-awesome.min.css', __FILE__);
    wp_register_style('coming_soon_widgets_style', plugins_url('/assets/css/coming-soon-widgets-style.css', __FILE__));
  }

  private function include_widgets_files()
  {
    require_once(__DIR__ . '/widgets/coming-soon.php');
  }

  public function register_widgets()
  {
    $this->include_widgets_files();

    \Elementor\Plugin::instance()->widgets_manager->register_widget_type(new Widgets\Coming_Soon());
  }

  public function __construct()
  {

    add_action('elementor/frontend/after_register_scripts', [$this, 'widget_scripts']);

    add_action('elementor/frontend/after_register_styles', [$this, 'widget_styles']);

    add_action('elementor/preview/enqueue_styles', function () {
      wp_enqueue_style('coming_soon_widgets_style');
    });

    add_action('elementor/widgets/widgets_registered', [$this, 'register_widgets']);
  }

}

Plugin::instance();